'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isPromise = require('./utils/isPromise');

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var noop = function noop() {};

exports.default = function () {
  var promises = [];

  var promisesMiddleware = function promisesMiddleware(_ref) {
    var dispatch = _ref.dispatch;
    var getState = _ref.getState;

    return function (next) {
      return function (action) {
        if (typeof action === 'function') {
          var _ret = (function () {
            var promise = action(dispatch, getState);
            if ((0, _isPromise2.default)(promise)) {
              promise = promise.then(noop, noop);
              promise.then(function () {
                promises = promises.filter(function (p) {
                  return p !== promise;
                });
              });
              promises.push(promise);
            }
            return {
              v: promise
            };
          })();

          if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
        } else {
          return next(action);
        }
      };
    };
  };

  promisesMiddleware.then = function (callback) {
    return Promise.all(promises).then(callback);
  };

  return promisesMiddleware;
};

module.exports = exports['default'];